package cz.upol.jj2.lab04;

import java.sql.*;

public class DatabaseClient {

	// vyznam konstant je jasny z nazvu
	private static final String DB_NAME = "jj2"; //zmena oproti textu
	private static final String HOST    = "database.inf.upol.cz:5432"; //zmena oproti textu

	private static final String USER = "jj2"; //zmena oproti textu

	private static final String PASSWORD = "KMIjazykjava_2";  // !!! FUJ !!!  zmena oproti textu

	private Connection con;
	
	/**
	 * Pripoji se k DB pres sitove rozhrani
	 */
	public void connect() throws SQLException {
		String connectionURL = "jdbc:postgresql://" + HOST + "/" + DB_NAME;  //zmena oproti textu
		
		// vytvori pripojeni
		con = DriverManager.getConnection(connectionURL, USER, PASSWORD); //zmena oproti textu
		System.out.println("Connecting to: " + connectionURL);
	}
	
	/** uzavre spojeni */ 
	public void close() throws SQLException {
		con.close();
	}
	
	/** vypise obsah tabulky "movies" */
	public void listMovies() throws SQLException {
		try (Statement stmt = con.createStatement()) {
		
			// provede dotaz
			stmt.executeQuery("SELECT * FROM movies");
			
			// ziska data
			try (ResultSet results = stmt.getResultSet()) {
			
				// je mozne ziskat i metadata ...
				ResultSetMetaData metaData = results.getMetaData();

				// ... treba sloupce ...
				System.out.println("Pocet sloupcu: " + metaData.getColumnCount());
				for (int i = 0; i < metaData.getColumnCount(); i++)
					// ... jejich nazvy a typy
					System.out.println(String.format("Sloupec #%1$s: %2$s\t(%3$s)",
							(i + 1),
							metaData.getColumnName(i + 1),
							metaData.getColumnTypeName(i + 1)));
				
				
				while (results.next()) {
					String name     = results.getString(1); // sloupce jsou indexovany od jedne!
					int releasedIn  = results.getInt(2);
					String director = results.getString("director"); // lze pristupovat i pres jmeno
					double rating   = results.getDouble("rating");
					System.out.println(name + ", " + director + ", " + releasedIn + ", " + rating);
				}
			}
		}
	}
	
	/** !!! toto je koncepcne spatne !!!
	 * NEPOUZIVAT
	 * vite proc?
 	**/
	public void insertMovie_DO_NOT_USE(String name, int releasedIn, String director, double rating) throws SQLException {
		try (Statement stmt = con.createStatement()) {
			String query = "INSERT INTO movies (name, released_in, director, rating) VALUES ('"
					+ name + "', " + releasedIn + ", '" + director + "', " + rating + ")";
			System.out.println("Query: " + query);
			stmt.executeUpdate(query);
		}
	}

	/** Lepsi pristup pres prepared statements.
	 * Mimo sanitizivani vstupu nabizeji i lepsi vykon (predkompilovane dotazy).
	 * To tady ale nevyuzijeme (vice v dokumentaci nebo tutorialu).
	 * **/
	public void insertMovie(String name, int releasedIn, String director, double rating) throws SQLException {
		String query = "INSERT INTO movies (name, released_in, director, rating) VALUES (?, ?, ?, ?)";
		try (PreparedStatement stmt = con.prepareStatement(query)) {
			stmt.setString(1, name);
			stmt.setInt(2, releasedIn);
			stmt.setString(3, director);
			stmt.setDouble(4, rating);
			stmt.executeUpdate();
		}
	}
	
	public static void main(String[] args) throws SQLException {
		DatabaseClient client = new DatabaseClient();
		client.connect();
		client.insertMovie("The Simpsons Movie", 2007, "David Silverman", 7.3);
		//client.insertMovie("A Bug's Life!", 1998, "John Lasseter", 7.2);
		client.listMovies();
		client.close();
	}

}
